unit Paga;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, Grids, ExtCtrls, ComCtrls, MPlayer, StdCtrls;

const LobN=10;TadelN=10;NamenZahl=10;HiscoreName='Paganitzu.hsc';
       // maximale Werte festlegen
       DiamantenMax=31;SpiderMax=12;SnakeMax=10;
       BeamerMax=13;SpeerMax=30;BildMax=37;
       Breit=15;Lang=11;FMax=15;
       Leer=0;Schlange=1;Wasser=2;Diamant=3;Schalter=4;ALL=5;Stein=6;Erde=7;
       Fels=8;Mauerstein=9;Schluessel=10;Tor=11;RohrW=12;Speer=13;Mauer=14;
       Granit=15;RohrS=16;RohrWOL=17;RohrWUL=18;RohrWOR=19;RohrWUR=20;
       Tod=21;ALR=22;Schuss=23;Explosion=24;Tod2=25;SZ1=26;SZ2=27;SZ3=28;
       Inschrift=29;Tor2=30;SpinnenTod1=31;SpinnenTod2=32;
       Spinne1=33;Spinne2=34;Spinne3=35;Spinne4=36;ZusatzDiamant=37;
       Farben:Array[1..FMax]of TColor=(clBlue, clGreen,  clRed,    clYellow,
                                       clAqua, clFuchsia,clGray,   clTeal,
                                       clLime, clLtGray, clMaroon, clNavy,
                                       clOlive,clPurple, clSilver);
       Namen:Array[1..NamenZahl]of String=('Gandalf','Frodo','Sam','Aragorn',
                                          'Legolas','Gimli','Pippin','Merry',
                                          'Boromir','Gollum');
       Lob:ARRAY[1..LobN]of String=
                ('prima','sehr gut','wow, good','exellent','very nice',
                 'weiter so','klasse','genial','sagenhaft','ultimativ');

     Tadel:Array[1..TadelN]of String=('aber ganz nett!','umsonst!','zu schlecht!',
                                       'mehr Glck das nchste Mal!',
                                       'noch einmal versuchen!','nicht aufgeben!',
                                       'versuch es noch einmal!','bemhe dich doch!!',
                                       'versuch es wieder!',
                                       'der nchste Versuch klappt bestimmt!');
     RiX:Array[1..4]of Integer=(-1,0,1,0); // Links, Hoch, Rechts, Runter
     RiY:Array[1..4]of Integer=(0,-1,0,1);
     Radius=30;

type
  TFeld=Array[-1..Breit+1,-1..Lang+1]of Integer;
  TPaganitzu = class(TForm)
    MainMenu: TMainMenu;
    Datei: TMenuItem;
    Editor: TMenuItem;
    Options: TMenuItem;
    Hilfe: TMenuItem;
    Hinweise: TMenuItem;
    N1: TMenuItem;
    Info: TMenuItem;
    BildSchlangeL: TImage;
    BildSchlangeR: TImage;
    BildWasser: TImage;
    BildDiamant: TImage;
    BildALLinksO: TImage;
    BildStein: TImage;
    BildErde: TImage;
    BildFels: TImage;
    BildMauerstein: TImage;
    BildKey: TImage;
    BildTor: TImage;
    BildRohrW: TImage;
    BildSpeer: TImage;
    BildALRechtsO: TImage;
    Ausgabe: TImage;
    BildLeer: TImage;
    BildSchalter: TImage;
    BildALLinksM: TImage;
    BildALRechtsM: TImage;
    BildALTodAsche: TImage;
    Laden: TMenuItem;
    Hiscore: TMenuItem;
    Abbruch: TMenuItem;
    N2: TMenuItem;
    Beenden: TMenuItem;
    DateiLesen: TOpenDialog;
    BildMauer: TImage;
    BildGranit: TImage;
    BildRohrS: TImage;
    BildRohrWOL: TImage;
    BildRohrWUL: TImage;
    BildRohrWOR: TImage;
    BildRohrWUR: TImage;
    Status: TPanel;
    StatusRaum: TPanel;
    StatusLeben: TPanel;
    StatusPunkte: TPanel;
    StatusBonus: TPanel;
    StatusKeys: TPanel;
    StatusHinweise: TPanel;
    Spiel: TMenuItem;
    TimerBonus: TTimer;
    LevelStart: TMenuItem;
    SelbstTod: TMenuItem;
    SoundAn: TMenuItem;
    MediaPlayer: TMediaPlayer;
    BildSchuss: TImage;
    BildExplosion: TImage;
    BildALTodAsche2: TImage;
    TimerTod: TTimer;
    BildSZ1: TImage;
    BildSZ2: TImage;
    BildSZ3: TImage;
    BildInschrift: TImage;
    BildTor2: TImage;
    TimerSpinne: TTimer;
    Leben99: TMenuItem;
    Ewig: TMenuItem;
    Reich: TMenuItem;
    Level: TMenuItem;
    Anfaenger: TMenuItem;
    Fortgeschrittener: TMenuItem;
    Experte: TMenuItem;
    EditPuffer: TEdit;
    TimerSpeer: TTimer;
    Spielstandspeichern: TMenuItem;
    SpielstandLaden: TMenuItem;
    BildSpinnenTod1: TImage;
    BildSpinnenTod2: TImage;
    StatusLevel: TPanel;
    TimerSnake: TTimer;
    BildSchlangeL2: TImage;
    BildSchlangeR2: TImage;
    TimerDiamenten: TTimer;
    BildDiamant2: TImage;
    BildDiamant3: TImage;
    BildDiamant4: TImage;
    ShapeGeheim: TShape;
    Uhr: TTimer;
    GeistrechtsO: TImage;
    GeistrechtsM: TImage;
    GeistlinksO: TImage;
    GeistlinksM: TImage;
    BildSpinneO: TImage;
    BildSpinneR: TImage;
    BildSpinneU: TImage;
    BildSpinneL: TImage;
    BildZusatzDiamant: TImage;
    procedure UhrTimer(Sender: TObject);
    procedure ShapeGeheimMouseDown(Sender: TObject; Button: TMouseButton;
                                   Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure LadenClick(Sender: TObject);
    procedure EditorClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure HinweiseClick(Sender: TObject);
    procedure InfoClick(Sender: TObject);
    procedure AbbruchClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure BeendenClick(Sender: TObject);
    procedure HiscoreClick(Sender: TObject);
    procedure TimerBonusTimer(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;Shift: TShiftState);
    procedure LevelStartClick(Sender: TObject);
    procedure SoundAnClick(Sender: TObject);
    procedure TimerTodTimer(Sender: TObject);
    procedure SelbstTodClick(Sender: TObject);
    procedure TimerSpinneTimer(Sender: TObject);
    procedure Leben99Click(Sender: TObject);
    procedure EwigClick(Sender: TObject);
    procedure ReichClick(Sender: TObject);
    procedure AnfaengerClick(Sender: TObject);
    procedure FortgeschrittenerClick(Sender: TObject);
    procedure ExperteClick(Sender: TObject);
    procedure TimerSpeerTimer(Sender: TObject);
    procedure SpielstandspeichernClick(Sender: TObject);
    procedure SpielstandLadenClick(Sender: TObject);
    procedure TimerSnakeTimer(Sender: TObject);
    procedure TimerDiamentenTimer(Sender: TObject);
    procedure DateiClick(Sender: TObject);
    procedure SpielClick(Sender: TObject);
    procedure LevelClick(Sender: TObject);
    procedure OptionsClick(Sender: TObject);
    procedure HilfeClick(Sender: TObject);

  private
    { Private-Deklarationen }
    // eigene Variablen
    AltFeld:TFeld;
    AltPunkte,Keys,Figur,GeistFigur,LevelMax:Integer;
    SpielEnde,Spider,Snake,linkeHand,rechteHand,unsterblich,Doppelt,mehrLeben,
    SpeerTod,SpinnenTod,Gestartet,SpielstandGeladen,Leuchten,Speere,Geist,
    Beamer,Fertig:Boolean;
    Geheim,SpielerName:String;
    AltPos,Position,TorPos:TPoint;
    SpeerBild,SchalterBild:TBitMap;
    SListe:Record Wo:Array[1..SnakeMax]of TPoint;N:Integer;end; // Schlangenliste
    SpeerListe:Record Wo:Array[1..SpeerMax]of TPoint;N:Integer;end;
    SpiderListe:Record Wo:Array[1..SpiderMax]of Record X,Y,Ri:Integer;end;N:Integer;end;
    // eigene Methoden
    procedure Init;
    procedure CopyRight;
    procedure FeldAusgabe;
    procedure LevelErzeugen;
    procedure NameErmitteln(Name:String;var SpielerName:String);
    procedure SchlangenTest;
    procedure Delay(Zeit:DWord);// Pausenzeit in Millisekunden
    procedure Sound(Datei:String);
    procedure Abrechnung;
    procedure SelbstZerstoerung;
    procedure NextLevel;
    procedure Abspann;
    procedure LevelWiederholung;
    procedure BeamerTest;
    procedure SpeerTest;
    procedure Sortieren(var L:TStrings);
    procedure HiscoreAktualisieren;
    procedure TimerAus;
    procedure TimerEin;
    procedure ALalsGeist;

  public
    { Public-Deklarationen }
    // ffentliche Variablen
    Bild:Array[0..BildMax]of TBitMap;
    BListe:Record Wo:Array[1..2*BeamerMax]of Record Von,Nach:TPoint;end;N:Integer;end; // Beamerliste
    DListe:Record Wo:Array[1..DiamantenMax]of TPoint;N:Integer;end; // Diamantenliste
    LevelMuster,HListe:TStrings;
    Feld:TFeld;
    SchalterAn:Boolean;
    Bonus,Leben,Punkte,LevelNr,LevelFaktor:Integer;
    Hinweis:String;
    // fr das Zeichnen auf dem Desktop
    DCanvas:TCanvas;
    DHandle:HWND; // HandleWindows
    Mitte,Delta:TPoint;
    MaxX,MaxY:Integer;
    // ffentliche Methoden
    procedure CopyRightName(var Name:String);
    procedure Codieren(var Zeile:String;Wie:Integer);

  end;

var
  Paganitzu: TPaganitzu;

implementation

uses LevelEditor, HilfeRegeln, Info, Passwort, Hiscore,
     InschriftGefunden, Spielstand;

{$R *.dfm}
{$R+,Q+}

 procedure TPaganitzu.Delay(Zeit:DWord);// Pausenzeit in Millisekunden
  var AltZeit:DWord;
  begin
   AltZeit:=GetTickCount;
   repeat Application.ProcessMessages until GetTickCount-AltZeit>Zeit
  end;

 procedure TPaganitzu.Sound(Datei:String);
  begin
   try
    MediaPlayer.DeviceType:=dtAutoSelect;
    MediaPlayer.FileName:=Datei;
    MediaPlayer.Open;
    MediaPlayer.Wait:=True;
    MediaPlayer.Play;
    MediaPlayer.Close;
   except
    On EMCIDeviceError do
     MessageDlg('Die Datei '+Datei+' wurde NICHT gefunden!',mtError,[mbRetry],0)
    end;
  end;

 procedure TPaganitzu.CopyRight;
  var Name:String;
      K,LA:Byte;
  Begin
   RandSeed:=3062;Name:='D_';Geheim:='';LA:=223;
   for K:=1 to 6 do
    Geheim:=Geheim+char(32+(ord(Name[K])-Random(LA)+LA-32) mod LA);
  End;

 procedure TPaganitzu.CopyRightName(var Name:String);
  var I:Byte; Code:String;
  begin
   RandSeed:=13;Code:='zы';Name:='';
   for I:=1 to Length(Code) do
    Name:=Name+char((ord(Code[I])-random(128)) and 255);
  end;

 procedure TPaganitzu.Codieren(var Zeile:String;Wie:Integer);
  var Geheim:String;
      K,LA:Integer;
  Begin
   Geheim:='';LA:=223;
   for K:=1 to Length(Zeile) do
    Geheim:=Geheim+char(32+(ord(Zeile[K])+Wie*Random(LA)+LA-32) mod LA);
   Zeile:=Geheim;
  End;

 procedure TPaganitzu.FormCreate(Sender: TObject);
  var Jahr,Monat,Tag:Word;
      Zeile,Wer:String;
      K,DateiNr,Count:Integer;
      Search:TSearchRec;
  begin
   SpielEnde:=True;Gestartet:=False;SpielstandGeladen:=False;
   unsterblich:=False;Doppelt:=False;mehrLeben:=False;
   SchalterAn:=True;KeyPreview:=False;Geist:=False;
   Fertig:=False;
   LevelMuster:=TStringList.Create;
   CopyRightName(Wer);CopyRight;
   DecodeDate(Now,Jahr,Monat,Tag);
   Caption:='Paganitzu - Die Suche nach der Diamantrose  '+IntToStr(Jahr)+'   '+Wer;
   SpeerBild:=TBitMap.Create;
   SchalterBild:=TBitMap.Create;
   Bild[0]:=BildLeer.Picture.Bitmap;
   Bild[1]:=BildSchlangeL.Picture.Bitmap;
   Bild[2]:=BildWasser.Picture.Bitmap;
   Bild[3]:=BildDiamant.Picture.Bitmap;
   Bild[4]:=BildSchalter.Picture.Bitmap;
   Bild[5]:=BildALLinksO.Picture.Bitmap;
   Bild[6]:=BildStein.Picture.Bitmap;
   Bild[7]:=BildErde.Picture.Bitmap;
   Bild[8]:=BildFels.Picture.Bitmap;
   Bild[9]:=BildMauerstein.Picture.Bitmap;
   Bild[10]:=BildKey.Picture.Bitmap;
   Bild[11]:=BildTor.Picture.Bitmap;
   Bild[12]:=BildRohrW.Picture.Bitmap;
   Bild[13]:=BildSpeer.Picture.Bitmap;
   Bild[14]:=BildMauer.Picture.Bitmap;
   Bild[15]:=BildGranit.Picture.Bitmap;
   Bild[16]:=BildRohrS.Picture.Bitmap;
   Bild[17]:=BildRohrWOL.Picture.Bitmap;
   Bild[18]:=BildRohrWUL.Picture.Bitmap;
   Bild[19]:=BildRohrWOR.Picture.Bitmap;
   Bild[20]:=BildRohrWUR.Picture.Bitmap;
   Bild[21]:=BildALTodAsche.Picture.Bitmap;
   Bild[22]:=BildALRechtsO.Picture.Bitmap;
   Bild[23]:=BildSchuss.Picture.Bitmap;
   Bild[24]:=BildExplosion.Picture.Bitmap;
   Bild[25]:=BildALTodAsche2.Picture.Bitmap;
   Bild[26]:=BildSZ1.Picture.Bitmap;
   Bild[27]:=BildSZ2.Picture.Bitmap;
   Bild[28]:=BildSZ3.Picture.Bitmap;
   Bild[29]:=BildInschrift.Picture.Bitmap;
   Bild[30]:=BildTor2.Picture.Bitmap;
   Bild[31]:=BildSpinnenTod1.Picture.Bitmap;
   Bild[32]:=BildSpinnenTod2.Picture.Bitmap;
   Bild[33]:=BildSpinneO.Picture.Bitmap;
   Bild[34]:=BildSpinneR.Picture.Bitmap;
   Bild[35]:=BildSpinneU.Picture.Bitmap;
   Bild[36]:=BildSpinneL.Picture.Bitmap;
   Bild[37]:=BildZusatzDiamant.Picture.Bitmap;
   HListe:=TStringList.Create;
   try
    HListe.LoadFromFile(HiscoreName);
    DateiNr:=FileAge(HiscoreName);
    RandSeed:=DateiNr;
    for K:=0 to HListe.Count-1 do
     begin
      Zeile:=HListe[K];
      Codieren(Zeile,-1); // entschlsseln
      HListe[K]:=Zeile;
     end;
   except
    MessageDlg('Datei '+HiscoreName+' nicht gefunden!',mtError,[mbOk],0);
    for K:=1 to 10 do
     HListe.Add(Format('%10d',[(11-K)*1000])+' - '+Format('%20s',[Namen[K]]));
   end;
   LevelMuster.LoadFromFile('Level1.lev');
   // decodieren
   DateiNr:=FileAge('Level1.lev');
   RandSeed:=DateiNr;
   for K:=0 to LevelMuster.Count-1 do
    begin
     Zeile:=LevelMuster[K];
     Codieren(Zeile,-1); // entschlsseln
     LevelMuster[K]:=Zeile;
    end;
   LevelNr:=1;LevelErzeugen;
   FeldAusgabe;randomize;
   AltFeld:=Feld;
   TimerSpinne.Interval:=200;
   TimerSpeer.Interval:=200;
   LevelFaktor:=2;MaxX:=0;
   Spielername:='';count:=0;
   if FindFirst('Level*.lev', $23, Search)= 0 then
    repeat
     inc(Count);
    until FindNext(Search)<>0;
   LevelMax:=Count;
  end;

 procedure TPaganitzu.LevelErzeugen;
  var x,y:Integer;
      Zeile:String;
      Zeichen:Char;
  begin
   FillChar(Feld,SizeOf(Feld),-1);
   for y:=0 to Lang do
    begin
     Zeile:=LevelMuster[y];
     for x:=0 to Length(Zeile)-1 do
      begin
       Zeichen:=Zeile[x+1];
       case Zeichen of
        ')' : Feld[x,y]:=ALL;
        '(' : Feld[x,y]:=ALR;
        ' ' : Feld[x,y]:=Leer;
        'W' : Feld[x,y]:=Wasser;
        '+' : Feld[x,y]:=Mauer;
        'T' : Feld[x,y]:=Tor;
        '*' : Feld[x,y]:=Stein;
        '=' : Feld[x,y]:=RohrW;
        'E' : Feld[x,y]:=Erde;
        'S' : Feld[x,y]:=Schlange;
        '#' : Feld[x,y]:=Schalter;
        'D' : Feld[x,y]:=Diamant;
        'K' : Feld[x,y]:=Schluessel;
        'F' : Feld[x,y]:=Fels;
        'G' : Feld[x,y]:=Granit;
        '^' : Feld[x,y]:=Speer;
        'M' : Feld[x,y]:=Mauerstein;
        '|' : Feld[x,y]:=RohrS;
        ';' : Feld[x,y]:=RohrWOL;
        ',' : Feld[x,y]:=RohrWUL;
        ':' : Feld[x,y]:=RohrWOR;
        '.' : Feld[x,y]:=RohrWUR;
        '1' : Feld[x,y]:=Spinne1;
        '2' : Feld[x,y]:=Spinne2;
        '3' : Feld[x,y]:=Spinne3;
        '4' : Feld[x,y]:=Spinne4;
        'z' : Feld[x,y]:=ZusatzDiamant;
        'I' : Feld[x,y]:=Inschrift;
        'a'..'l': Feld[x,y]:=ZusatzDiamant+1+ord(Zeichen)-ord('a'); // Beamer
       end;
      end;
    end;
   if Lang<LevelMuster.Count-1 then Hinweis:=LevelMuster[Lang+1]
   else Hinweis:='';
   for y:=Lang+2 to LevelMuster.Count-1 do
    Hinweis:=Hinweis+#13+LevelMuster[y];
  end;

 procedure TPaganitzu.FeldAusgabe;
  var x,y:Integer;
  begin
   For x:=0 to Breit do
    For y:=0 to Lang do
     if not SchalterAn then
      begin
       if Feld[x,y] in[ALL,ALR] then Ausgabe.Canvas.Draw(40*x,40*y,Bild[Feld[x,y]])
       else Ausgabe.Canvas.Draw(40*x,40*y,Bild[Leer])
      end
     else
      begin
       if Feld[x,y]<ZusatzDiamant then Ausgabe.Canvas.Draw(40*x,40*y,Bild[Feld[x,y]])
       else Ausgabe.Canvas.Draw(40*x,40*y,Bild[Leer])
      end;
  end;

 procedure TPaganitzu.LadenClick(Sender: TObject);
  var Zahl,FileText,Zeile:String;
      DateiNr,K:Integer;
      OK:Boolean;
  begin
   PasswordDlg.Caption:='freie Raumwahl';
   PasswordDlg.LabelPasswort.Caption:='Gib deine Codezahl ein!';
   PasswordDlg.Passwort.PasswordChar:='?';
   PasswordDlg.Passwort.Text:='';
   PasswordDlg.Passwort.MaxLength:=12;
   PasswordDlg.ShowModal;
   Zahl:=PasswordDlg.Passwort.Text;
   OK:=False;
   if Zahl=Geheim then OK:=True; // 7xx
   if Length(Zahl)=3 then
    begin
     Zeile:=copy(Zahl,2,2);K:=StrToInt(Zeile);
     if (Zahl[1]='7') and (K<=LevelMax) and (K>0) then OK:=True;
    end;
   if not OK then
    begin
     MessageDlg('Dir fehlt der Masterkey!',mtError,[mbOk],0);
     TimerEin;
     exit;
    end;
   with DateiLesen do
    begin
     ForceCurrentDirectory:=True;
     Filter:='Paganitzudateien (*.lev) |*.lev';
     DefaultExt:='lev';
     if Execute then
      begin
       LevelMuster.LoadFromFile(FileName);
       DateiNr:=FileAge(FileName);
       RandSeed:=DateiNr;
       for K:=0 to LevelMuster.Count-1 do
        begin
         Zeile:=LevelMuster[K];
         Codieren(Zeile,-1); // entschlsseln
         LevelMuster[K]:=Zeile;
        end;
       FileText:=ExtractFileName(FileName);
       Delete(FileText,pos('.',FileText),4); // '.lev' wird gelscht
       Delete(FileText,1,5); // 'Level' wird gelscht
       LevelNr:=StrToInt(FileText);
       if Length(FileText)=1 then FileText:='0'+FileText;
       StatusRaum.Caption:='Raum '+FileText;
       LevelErzeugen;
       AltFeld:=Feld;
       if not mehrLeben then Leben:=5;
       if Spielername='' then NameErmitteln('Spieler',SpielerName);
       StatusHinweise.Caption:='Versuch dein Glck, '+SpielerName+'!';
       Init;
       Ausgabe.Cursor:=crNone;
       Gestartet:=True;
      end
    end
  end;

 procedure TPaganitzu.SpielstandLadenClick(Sender: TObject);
  var FileText,Zeile:String;
      K,DateiNr:Integer;
  begin
   with DateiLesen do
    begin
     ForceCurrentDirectory:=True;
     Filter:='Spieldateien (*.sav) |*.sav';
     DefaultExt:='sav';
     if Execute then
      begin
       LevelMuster.LoadFromFile(FileName);
       FileText:=ExtractFileName(FileName);
       // Datei entschlsseln
       DateiNr:=FileAge(FileName);
       RandSeed:=DateiNr;
       for K:=0 to LevelMuster.Count-1 do
        begin
         Zeile:=LevelMuster[K];
         Codieren(Zeile,-1); // entschlsseln
         LevelMuster[K]:=Zeile;
        end;
       SpielstandGeladen:=True;
       Delete(FileText,1,9); // 'File 1 - ' wird gelscht
       Delete(FileText,pos('.',FileText),4); // '.sav' wird gelscht
       Delete(FileText,1,6); // 'Level ' wird gelscht
       LevelNr:=StrToInt(FileText);
       if Length(FileText)=1 then FileText:='0'+FileText;
       StatusRaum.Caption:='Raum '+FileText;
       Punkte:=StrToInt(LevelMuster[0]);
       LevelMuster.Delete(0);
       Leben:=StrToInt(LevelMuster[0]);
       LevelMuster.Delete(0);
       Bonus:=StrToInt(LevelMuster[0]);
       LevelMuster.Delete(0);
       LevelFaktor:=StrToInt(LevelMuster[0]);
       LevelMuster.Delete(0);
       if LevelMuster[0]='True' then mehrLeben:=True else mehrLeben:=False;
       LevelMuster.Delete(0);
       if LevelMuster[0]='True' then unsterblich:=True else unsterblich:=False;
       LevelMuster.Delete(0);
       if LevelMuster[0]='True' then Doppelt:=True else Doppelt:=False;
       LevelMuster.Delete(0);
       if LevelMuster[0]='True' then SchalterAn:=True else SchalterAn:=False;
       LevelMuster.Delete(0);
       if mehrLeben then Leben:=99;
       StatusLeben.Caption:='Leben '+IntToStr(Leben);
       StatusPunkte.Caption:='Punkte '+IntToStr(Punkte);
       StatusLevel.Caption:='Level '+IntToStr(LevelFaktor);
       case LevelFaktor of
        1 : Anfaenger.Checked:=True;
        2 : Fortgeschrittener.Checked:=True;
        3 : Experte.Checked:=True;
       end;
       Leben99.Checked:=mehrLeben;
       Ewig.Checked:=unsterblich;
       Reich.Checked:=Doppelt;
       Gestartet:=True;
       LevelErzeugen;
       AltFeld:=Feld;
       if Spielername='' then NameErmitteln('Spieler',SpielerName);
       StatusHinweise.Caption:='Versuch dein Glck, '+SpielerName+'!';
       Init;
      end
    end
  end;

 procedure TPaganitzu.EditorClick(Sender: TObject);
  var Zahl:String;
  begin
   TimerAus;
   if not SpielEnde then AbbruchClick(Self);
   PasswordDlg.Caption:='Paworteingabe';
   PasswordDlg.LabelPasswort.Caption:='Gib deine Codezahl ein!';
   PasswordDlg.Passwort.PasswordChar:='?';
   PasswordDlg.Passwort.Text:='';
   PasswordDlg.Passwort.MaxLength:=12;
   PasswordDlg.ShowModal;
   Zahl:=PasswordDlg.Passwort.Text;
   if Zahl=Geheim then PagaEditor.ShowModal
   else MessageDlg('Dir fehlt der Masterkey!',mtError,[mbOk],0);
  end;

 procedure TPaganitzu.FormDestroy(Sender: TObject);
  begin
   LevelMuster.Free;
  end;

 procedure TPaganitzu.HinweiseClick(Sender: TObject);
  begin
   RegelnBox.ShowModal;
   TimerEin;
  end;

 procedure TPaganitzu.InfoClick(Sender: TObject);
  begin
   InfoBox.ShowModal;
   TimerEin;
  end;

 procedure TPaganitzu.NameErmitteln(Name:String;var SpielerName:String);
  const Max=22;
        NameListe:Array[1..Max]of String=('Ahab','Brsel','Meister','Schrder',
                                          'Jacobs','Schneider','Nelson',
                                          'Columbus','Magellan','Nemo',
                                          'Gandalf','Frodo','Sam','Aragorn',
                                          'Legolas','Gimli','Pippin','Merry',
                                          'Boromir','Gollum','Eowyn','Fiete');
  var Zahl,ersterBuchstabe:String;
  begin
   SpielerName:='';
   PasswordDlg.Caption:='Dein Name, '+Name+'?';
   PasswordDlg.LabelPasswort.Caption:='AL braucht Dich!';
   PasswordDlg.Passwort.PasswordChar:=#0;
   PasswordDlg.Passwort.MaxLength:=12;
   PasswordDlg.Passwort.Text:=NameListe[random(Max)+1];
   repeat
    PasswordDlg.ShowModal;
    SpielerName:=PasswordDlg.Passwort.Text;
    while Pos(' ',SpielerName)>0 do  // lscht alle Leerzeichen
     begin Delete(SpielerName,Pos(' ',SpielerName),1) end;
    if Length(SpielerName)<3 then
     PasswordDlg.Passwort.Text:=NameListe[random(Max)+1];
   until Length(SpielerName)>2;
   SpielerName:=AnsiLowerCase(SpielerName);
   ersterBuchstabe:=AnsiUpperCase(SpielerName[1]);
   SpielerName[1]:=ersterBuchstabe[1];
   if (AnsiUpperCase(SpielerName)='MEISTER') or
      (AnsiUpperCase(SpielerName)='FIETE') then
    begin
     PasswordDlg.Caption:='Paworteingabe';
     PasswordDlg.LabelPasswort.Caption:='Gib deine Codezahl ein!';
     PasswordDlg.Passwort.PasswordChar:='?';
     PasswordDlg.Passwort.Text:='';
     PasswordDlg.ShowModal;
     Zahl:=PasswordDlg.Passwort.Text;
     if Zahl<>Geheim then SpielerName:='Betrger';
    end;
  end;

 procedure TPaganitzu.Init;
  var x,y,Zufall,BN,Nr,K:Integer;
  begin
   Keys:=0;
   Spider:=False;Snake:=False;Leuchten:=False;Speere:=False;Beamer:=False;
   TimerAus; // alle Timer deaktiviert
   SchalterAn:=True;
   for x:=0 to Breit do
    for y:=0 to Lang do
     if Feld[x,y]=Schalter then SchalterAn:=False;
   if not SpielstandGeladen then Bonus:=500;
   Feld:=AltFeld;
   FeldAusgabe;
   FillChar(SListe,SizeOf(SListe),0); // Schlangenliste
   FillChar(DListe,SizeOf(DListe),0); // Diamantenliste
   FillChar(SpeerListe,SizeOf(SpeerListe),0); // Speerliste
   FillChar(BListe,SizeOf(BListe),-1); // Beamerliste
   FillChar(SpiderListe,SizeOf(SpiderListe),0); // Spinnenliste
   for x:=0 to Breit do
    for y:=0 to Lang do
     begin
      if Feld[x,y] in[ALL,ALR] then
       begin
        Position.X:=x;
        Position.Y:=y;
        Figur:=Feld[x,y];
       end;
      if Feld[x,y]=Tor then
       begin
        TorPos.X:=x;
        TorPos.Y:=y;
       end;
      if Feld[x,y]=Schluessel then inc(Keys);
      if Feld[x,y] in[Spinne1..Spinne4] then
       begin
        Spider:=True;SpinnenTod:=False;
        linkeHand:=False;rechteHand:=False;
        if SpiderListe.N<SpiderMax then
         begin
          inc(SpiderListe.N);
          SpiderListe.Wo[SpiderListe.N].X:=x;
          SpiderListe.Wo[SpiderListe.N].Y:=y;
          SpiderListe.Wo[SpiderListe.N].Ri:=Feld[x,y]-32;
          if SpiderListe.Wo[SpiderListe.N].Ri<3 then linkeHand:=True
          else rechteHand:=True;
         end
        else MessageDlg('Es sind nur '+IntToStr(SpiderMax)+' Spinnen mglich!!!',mtError,[mbRetry],0);
       end;
      if Feld[x,y]=Schlange then
       begin
        Snake:=True;
        if SListe.N<SnakeMax then
         begin
          inc(SListe.N);
          SListe.Wo[SListe.N].X:=x;
          SListe.Wo[SListe.N].Y:=y;
         end
        else MessageDlg('Es sind nur '+IntToStr(SnakeMax)+' Schlangen mglich!!!',mtError,[mbRetry],0);
       end;
      if Feld[x,y]=Speer then
       begin
        SpeerTod:=False;Speere:=True;
        if SpeerListe.N<SpeerMax then
         begin
          inc(SpeerListe.N);
          SpeerListe.Wo[SpeerListe.N].X:=x;
          SpeerListe.Wo[SpeerListe.N].Y:=y;
         end
        else MessageDlg('Es sind nur '+IntToStr(SpeerMax)+' Speere mglich!!!',mtError,[mbRetry],0);
       end;
      if Feld[x,y]=Diamant then
       begin
        Leuchten:=True;
        if DListe.N<DiamantenMax then
         begin
          inc(DListe.N);
          DListe.Wo[DListe.N].X:=x;
          DListe.Wo[DListe.N].Y:=y;
         end
        else MessageDlg('Es sind nur '+IntToStr(DiamantenMax)+' Diamanten mglich!!!',mtError,[mbRetry],0);
       end;
     end;
   // Zusatzdiamanten
   for x:=0 to Breit do
    for y:=0 to Lang do
     begin
      if Feld[x,y]=ZusatzDiamant then
       begin
        Feld[x,y]:=Diamant;
        Zufall:=random(5)+7;
        if Zufall>9 then Zufall:=Zufall+4;
        Ausgabe.Canvas.Draw(40*x,40*y,Bild[Zufall]);
       end;
      if Feld[x,y]=Inschrift then
       begin
        Feld[x,y]:=Inschrift;
        Ausgabe.Canvas.Draw(40*x,40*y,Bild[Diamant]);
       end;
     end;
   // Beamer
   BN:=0;
   for x:=0 to Breit do
    for y:=0 to Lang do
     begin
      if Feld[x,y]>ZusatzDiamant then
       begin
        Nr:=2*(Feld[x,y]-ZusatzDiamant)-1; // ungerader Index
        Feld[x,y]:=Leer;
        if BListe.Wo[Nr].Von.X=-1 then
         begin
          inc(BN);
          BListe.Wo[Nr].Von.X:=x;
          BListe.Wo[Nr].Von.Y:=y;
         end
        else
         begin
          BListe.Wo[Nr].Nach.X:=x;
          BListe.Wo[Nr].Nach.Y:=y;
         end;
       end;
     end;
   for K:=1 to BN do
    begin
     BListe.Wo[2*K].Von:=BListe.Wo[2*K-1].Nach;
     BListe.Wo[2*K].Nach:=BListe.Wo[2*K-1].Von;
    end;
   BListe.N:=2*BN;
   Beamer:=BListe.N>0;
   KeyPreview:=True;
   StatusBonus.Caption:='Bonus '+IntToStr(Bonus);
   StatusKeys.Caption:='Schlssel '+IntToStr(Keys);
   if Hinweis<>'' then MessageDlg(Hinweis,mtInformation,[mbOk],0);
   SpielEnde:=False;
   TimerEin;
   Ausgabe.Cursor:=crNone;
   AltPunkte:=Punkte;
  end;

 procedure TPaganitzu.LevelStartClick(Sender: TObject);
  var Zeile,FileName:String;
      DateiNr,K:Integer;
  begin
   if Gestartet then
    begin
     MessageDlg('Das Spiel luft bereits!',mtError,[mbOk],0);
     exit;
    end;
   if SoundAn.Checked then Sound('Welcome.wav');
   LevelNr:=1;Geist:=False;
   MessageDlg(IntToStr(LevelMax)+' Abenteuer sind zu bestehen!',mtInformation,[mbOk],0);
   FileName:='Level'+IntToStr(LevelNr)+'.lev';
   LevelMuster.LoadFromFile(FileName);
   DateiNr:=FileAge(FileName);
   RandSeed:=DateiNr;
   for K:=0 to LevelMuster.Count-1 do
    begin
     Zeile:=LevelMuster[K];
     Codieren(Zeile,-1); // entschlsseln
     LevelMuster[K]:=Zeile;
    end;
   LevelErzeugen;
   AltFeld:=Feld;
   SpielstandGeladen:=False;
   Init;
   Punkte:=0;unsterblich:=False;Doppelt:=False;mehrLeben:=False;
   Leben99.Checked:=mehrLeben;Ewig.Checked:=unsterblich;Reich.Checked:=Doppelt;
   Leben:=5;Gestartet:=True;
   StatusLeben.Caption:='Leben '+IntToStr(Leben);
   StatusPunkte.Caption:='Punkte '+IntToStr(Punkte);
   LevelNr:=1;
   NameErmitteln('Spieler',SpielerName);
   StatusHinweise.Caption:='Versuch dein Glck, '+SpielerName+'!';
   TimerEin;Ausgabe.Cursor:=crNone;
  end;

 procedure TPaganitzu.AbbruchClick(Sender: TObject);
  begin
   if MessageDlg('Willst du die Suche abbrechen?',
                 mtConfirmation,[mbYes,mbNo],0)=mrYes then
    begin
     KeyPreView:=False; // keine Tasteneingabe mglich
     TimerAus;
     SpielEnde:=True;Gestartet:=False;
     Screen.Cursor:=crDefault;
     StatusHinweise.Caption:='Spielende';
     MessageDlg('Abbruch, Feigling!',mtInformation,[mbOk],0);
     HiscoreAktualisieren;
    end;
  end;

 procedure TPaganitzu.FormCloseQuery(Sender: TObject;var CanClose: Boolean);
  var K,DateiNr:Integer;
      Zeile:String;
  begin
   if MessageDlg('Willst du die Buddelei beenden?',
                  mtConfirmation,[mbYes,mbNo],0)=mrYes then
    begin
     TimerAus;
     try
      DateiNr:=DateTimeToFileDate(Now);
      RandSeed:=DateiNr;
      for K:=0 to HListe.Count-1 do
       begin
        Zeile:=HListe[K];
        Codieren(Zeile,1); // verschlsseln
        HListe[K]:=Zeile;
       end;
      HListe.SaveToFile(HiscoreName);
      if FileSetDate(HiscoreName,DateiNr)<>0 then
       MessageDlg('Fehler beim Speichern der Scores!',mtError,[mbOk],0)
     except
       MessageDlg('Datei '+HiscoreName+' kann nicht gespeichert werden!',mtError,[mbOk],0);
      end;
     if SoundAn.Checked then Sound('Goodbye.wav');
     if Fertig then
      MessageDlg('Das Abenteuer ist zu Ende!!',mtInformation,[mbOk],0)
     else MessageDlg('Die Diamantrose bleibt versteckt!!',mtInformation,[mbOk],0);
     CanClose:=True
    end
   else CanClose:=False
  end;

 procedure TPaganitzu.BeendenClick(Sender: TObject);
  begin close end;

 procedure TPaganitzu.HiscoreClick(Sender: TObject);
  begin
   HSL.ShowModal;
   TimerEin;
  end;

 procedure TPaganitzu.TimerBonusTimer(Sender: TObject);
  begin
   if TimerBonus.Enabled and (Bonus>0) then
    begin dec(Bonus);StatusBonus.Caption:='Bonus '+IntToStr(Bonus) end;
  end;

 procedure TPaganitzu.Sortieren(var L:TStrings);
  var sortiert:Boolean;
      K:Integer;
      Tausch:String;
  begin
   repeat
    sortiert:=True;
    for K:=0 to L.Count-2 do
     if L[K]<L[K+1] then
      begin
       Tausch:=L[K];
       L[K]:=L[K+1];
       L[K+1]:=Tausch;
       sortiert:=False;
      end
   until sortiert
  end;

 procedure TPaganitzu.HiscoreAktualisieren;
  var Zeile:String;
      Minimum:Integer;
  begin
   Zeile:=HListe[HListe.Count-1];
   Minimum:=StrToInt(copy(Zeile,1,Pos(' -',Zeile)-1));
   if Minimum<Punkte then
    begin
     HListe.Add(Format('%10d',[Punkte])+' - '+Format('%20s',[SpielerName]));
     Sortieren(HListe);
     HListe.Delete(HListe.Count-1);
     HSL.ShowModal;
    end;
  end;

 procedure TPaganitzu.Abrechnung;
  begin
   SpielEnde:=True;Gestartet:=False;
   TimerAus;
   Screen.Cursor:=crDefault;
   MessageDlg('Da du kein Leben mehr besitzt, ist das Spiel Zu Ende!',mtInformation,[mbOk],0);
   HiscoreAktualisieren;
  end;

 procedure TPaganitzu.SelbstZerstoerung;
  begin
   TimerAus;
   Ausgabe.Canvas.Draw(40*Position.X,40*Position.Y,Bild[SZ1]);
   Delay(200);
   Ausgabe.Canvas.Draw(40*Position.X,40*Position.Y,Bild[SZ2]);
   Delay(200);
   Ausgabe.Canvas.Draw(40*Position.X,40*Position.Y,Bild[SZ3]);
   LevelWiederholung;
  end;

 procedure TPaganitzu.Abspann;
  begin
   MessageDlg('Du hast die Diamantrose gefunden!',mtInformation,[mbOk],0);
   KeyPreview:=False;
   TimerAus;
   SpielEnde:=True;Gestartet:=False;
   Screen.Cursor:=crDefault;
   InschriftBild.Inschrift.Picture.LoadFromFile('Abspann1.jpg');
   InschriftBild.ShowModal;
   InschriftBild.Inschrift.Picture.LoadFromFile('Abspann2.jpg');
   InschriftBild.ShowModal;
   HiscoreAktualisieren;
  end;

 procedure TPaganitzu.NextLevel;
  var Zeile,FileName:String;
      DateiNr,K:Integer;
  begin
   FileName:='Level'+IntToStr(LevelNr)+'.lev';
   LevelMuster.LoadFromFile(FileName);
   DateiNr:=FileAge(FileName);
   RandSeed:=DateiNr;
   for K:=0 to LevelMuster.Count-1 do
    begin
     Zeile:=LevelMuster[K];
     Codieren(Zeile,-1); // entschlsseln
     LevelMuster[K]:=Zeile;
    end;
   SpielstandGeladen:=False;
   LevelErzeugen; // Feld wird erzeugt
   AltFeld:=Feld;
   Init;
   Zeile:=IntToStr(LevelNr);
   if LevelNr<10 then Zeile:='0'+Zeile;
   StatusHinweise.Caption:='Versuch dein Glck, '+SpielerName+'!';
   StatusRaum.Caption:='Raum '+Zeile;
  end;

 procedure TPaganitzu.LevelWiederholung;
  begin
   KeyPreview:=False;
   TimerAus;
   dec(Leben);
   StatusHinweise.Caption:=Tadel[random(TadelN)+1];
   if Leben>=0 then StatusLeben.Caption:='Leben '+IntToStr(Leben)
   else StatusLeben.Caption:='AL als Geist';
   if not SpeerTod then TimerTod.Enabled:=True;
   MessageDlg('ein Leben weniger!',mtInformation,[mbOk],0);
   TimerTod.Enabled:=False;
   if Leben=0 then
    begin SpielEnde:=True;Abrechnung end
   else if Leben<0 then
    begin
     Geist:=True;
     KeyPreview:=True;
     MessageDlg('Du lebst als Geist weiter!',mtInformation,[mbOk],0);
    end
   else Init;
  end;

 procedure TPaganitzu.TimerTodTimer(Sender: TObject);
  begin
   if SpinnenTod then
    begin
     Ausgabe.Canvas.Draw(40*Position.X,40*Position.Y,Bild[SpinnenTod1]);
     if SoundAn.Checked then Sound('drop.wav')
     else Delay(200);
     Ausgabe.Canvas.Draw(40*Position.X,40*Position.Y,Bild[SpinnenTod2]);
     TimerTod.Enabled:=False;
     Feld[Position.X,Position.Y]:=SpinnenTod2;
    end
   else // Schlange
    begin
     Ausgabe.Canvas.Draw(40*Position.X,40*Position.Y,Bild[Tod]);
     if SoundAn.Checked then Sound('Fehler.wav')
     else Delay(200);
     Ausgabe.Canvas.Draw(40*Position.X,40*Position.Y,Bild[Tod2]);
     TimerTod.Enabled:=False;
     Feld[Position.X,Position.Y]:=Tod2;
    end
  end;

 procedure TPaganitzu.TimerSpeerTimer(Sender: TObject); // Test ob AL stirbt
  var K,L,H,xn,yn:Integer;
      Ende:Boolean;
  begin
   for K:=1 to SpeerListe.N do
    if (Position.X=SpeerListe.Wo[K].X) and (Position.Y<SpeerListe.Wo[K].Y) then // Speer und AL in selben Spalte
     begin
      xn:=Position.X;yn:=Position.Y;  // AL's Position
      Ende:=True;H:=SpeerListe.Wo[K].Y-yn+1; // Speerlnge
      for L:=yn+1 to SpeerListe.Wo[K].Y-1 do Ende:=Ende and (Feld[xn,L]=Speer);
      if Ende and not unsterblich then
       begin
        TimerSpeer.Enabled:=False;
        SpeerTod:=True;
        KeyPreview:=False;TimerBonus.Enabled:=False;
        SpeerBild.LoadFromFile('SpeerTod'+IntToStr(H)+'.bmp');
        Ausgabe.Canvas.Draw(40*Position.X,40*Position.Y,SpeerBild);
        if SoundAn.Checked then Sound('click.wav');
        LevelWiederholung;
       end
     end
  end;

 procedure TPaganitzu.SpeerTest;
  var K,L,xn,yn,Teil:Integer;
  begin
   TimerSpeer.Enabled:=False;
   for K:=1 to SpeerListe.N do
    if (Position.X=SpeerListe.Wo[K].X) and (Position.Y<SpeerListe.Wo[K].Y) then // Speer und AL in selben Spalte
     begin
      xn:=Position.X;yn:=Position.Y;  // AL's Position
      Teil:=0; // Leerteilezhler
      for L:=SpeerListe.Wo[K].Y-1 downto yn+1 do
       begin
        if Feld[xn,L] in[Leer,ALL,ALR] then inc(Teil)
        else
         begin
          if Feld[xn,L]=Stein then dec(Teil);
          break;
         end;
       end;
      if Teil>0 then
       begin
        SpeerBild.LoadFromFile('SpeerL'+IntToStr(Teil+1)+'.bmp');
        Ausgabe.Canvas.Draw(40*xn,40*(SpeerListe.Wo[K].Y-Teil),SpeerBild);
       end;
      for L:=1 to Teil do Feld[xn,SpeerListe.Wo[K].Y-L]:=Speer;
      TimerSpeer.Enabled:=True;
     end;
  end;

 procedure TPaganitzu.SchlangenTest;
  var K,L,xn,yn:Integer;
      Ende:Boolean;
  begin
   for K:=1 to SListe.N do
    if Position.Y=SListe.Wo[K].Y then // Schlange und AL in selben Zeile
     begin
      xn:=Position.X;yn:=Position.Y;  // AL's Position
      Ende:=True;
      if xn<SListe.Wo[K].X then
       for L:=xn+1 to SListe.Wo[K].X-1 do Ende:=Ende and (Feld[L,yn]=Leer)
      else for L:=xn-1 downto SListe.Wo[K].X+1 do Ende:=Ende and (Feld[L,yn]=Leer);
      if Ende then
       begin
        KeyPreview:=False;
        TimerAus;
        if xn<SListe.Wo[K].X then
         for L:=SListe.Wo[K].X-1 downto xn do
          begin
           Ausgabe.Canvas.Draw(40*L,40*yn,Bild[Schuss]);
           Delay(50);
           Ausgabe.Canvas.Draw(40*L,40*yn,Bild[Leer]);
          end
        else
         for L:=SListe.Wo[K].X+1 to xn do
          begin
           Ausgabe.Canvas.Draw(40*L,40*yn,Bild[Schuss]);
           Delay(50);
           Ausgabe.Canvas.Draw(40*L,40*yn,Bild[Leer]);
          end;
        Ausgabe.Canvas.Draw(40*Position.X,40*Position.Y,Bild[Explosion]);
        Delay(200);
        LevelWiederholung;
        exit; // Aussprung da schon tot
       end;
     end;
  end;

 procedure TPaganitzu.BeamerTest;
  var K:Integer;
  begin
   for K:=1 to BListe.N do
    if (Position.X=BListe.Wo[K].Von.X) and (Position.Y=BListe.Wo[K].Von.Y) then
     begin
      TimerAus;
      Ausgabe.Canvas.Draw(40*Position.X,40*Position.Y,Bild[SZ1]);
      Delay(200);
      Ausgabe.Canvas.Draw(40*Position.X,40*Position.Y,Bild[SZ2]);
      Delay(200);
      Ausgabe.Canvas.Draw(40*Position.X,40*Position.Y,Bild[SZ3]);
      Delay(200);
      Ausgabe.Canvas.Draw(40*Position.X,40*Position.Y,Bild[Leer]);
      Feld[Position.X,Position.Y]:=Leer; // AL lschen
      Position.X:=BListe.Wo[K].Nach.X;
      Position.Y:=BListe.Wo[K].Nach.Y;
      Feld[Position.X,Position.Y]:=Figur;
      Ausgabe.Canvas.Draw(40*Position.X,40*Position.Y,Bild[Figur]);
      TimerEin;
      exit; // genau einmal wird gebeamt
     end
  end;

 procedure TPaganitzu.ALalsGeist;
  begin
   TimerAus;KeyPreView:=False;
   if Figur=ALL then
    begin
     Ausgabe.Canvas.Draw(40*AltPos.X,40*AltPos.Y,GeistlinksM.Picture.Bitmap);
     Delay(50);
     Ausgabe.Canvas.Draw(40*Position.X,40*Position.Y,GeistlinksO.Picture.Bitmap);
    end
   else
    begin
     Ausgabe.Canvas.Draw(40*AltPos.X,40*AltPos.Y,GeistrechtsM.Picture.Bitmap);
     Delay(50);
     Ausgabe.Canvas.Draw(40*Position.X,40*Position.Y,GeistrechtsO.Picture.Bitmap);
    end;
   Ausgabe.Canvas.Draw(40*AltPos.X,40*AltPos.Y,Bild[GeistFigur]);
   TimerEin;KeyPreView:=True;
  end;

 procedure TPaganitzu.FormKeyDown(Sender: TObject; var Key: Word;Shift: TShiftState);
  var Inhalt,K,L,Faktor:Integer;
      Menge:Set of Byte;
      Zeile:String;
      Vorhanden:Boolean;
  begin
   if SpielEnde then
    begin
     MessageDlg('Das Spiel mu erst gestartet werden!!!',mtError,[mbRetry],0);
     exit;
    end;
   if not TimerBonus.Enabled then TimerEin; // Menuepunkt angeschaut aber nicht aktiviert
   if not(Key in[VK_Escape,VK_Left,VK_Up,VK_Right,VK_Down,VK_F6]) then exit; // falsche Taste
   if Key=VK_Escape then
    begin
     AbbruchClick(Self);
     exit;
    end;
   AltPos:=Position;
   if Key=VK_F6 then begin SelbstZerstoerung;exit end;
   if Key=VK_Left  then Dec(Position.x);
   if Key=VK_Up    then Dec(Position.y);
   if Key=VK_Right then Inc(Position.x);
   if Key=VK_Down  then Inc(Position.y);
   if (Position.X<0) or (Position.Y<0) or (Position.X>Breit) or (Position.Y>Lang) then
    begin
     Position:=AltPos;
     exit;
    end;
   if Geist then
    begin
     if Key=VK_Right then Figur:=ALR;
     if Key=VK_Left  then Figur:=ALL;
     GeistFigur:=Feld[AltPos.X,AltPos.Y];
     ALalsGeist;
     exit;
    end;
   Inhalt:=Feld[Position.X,Position.Y];
   // darf AL sich bewegen?
   KeyPreView:=False;
   Menge:=[Leer,Erde,Schluessel,Diamant,Inschrift];
   if Keys=0 then Menge:=Menge+[Tor];
   if Inhalt in Menge+[Stein] then
    begin
     if Key=VK_Right then Figur:=ALR;
     if Key=VK_Left  then Figur:=ALL;
     if Inhalt in Menge then
      begin
       if Inhalt<>Diamant then
        begin
         Feld[AltPos.X,AltPos.Y]:=Leer;
         if Key=VK_Right then
          begin
           Ausgabe.Canvas.Draw(40*AltPos.X,40*AltPos.Y,BildALRechtsM.Picture.Bitmap);
           if not SoundAn.Checked then Delay(15);
          end
         else
          if Key=VK_Left then
          begin
           Ausgabe.Canvas.Draw(40*AltPos.X,40*AltPos.Y,BildALLinksM.Picture.Bitmap);
           if not SoundAn.Checked then Delay(15);
          end;
         if SoundAn.Checked then Beep;
         Ausgabe.Canvas.Draw(40*AltPos.X,40*AltPos.Y,Bild[Leer]);
         Feld[Position.X,Position.Y]:=Figur;
         Ausgabe.Canvas.Draw(40*Position.X,40*Position.Y,Bild[Figur]);
         if Spider then
          if not unsterblich then
           if not SpinnenTod then
            if (Feld[Position.X-1,Position.Y] in[Spinne1..Spinne4]) or
               (Feld[Position.X+1,Position.Y] in[Spinne1..Spinne4]) or
               (Feld[Position.X,Position.Y-1] in[Spinne1..Spinne4]) or
               (Feld[Position.X,Position.Y+1] in[Spinne1..Spinne4]) then
                begin
                 SpinnenTod:=True;LevelWiederholung;
                 KeyPreView:=True;exit;
                end; // AL berhrt Spinne
        end;
       if not SchalterAn then
        if (Feld[Position.X-1,Position.Y]=Schalter) or (Feld[Position.X+1,Position.Y]=Schalter) then
         begin
          MessageDlg('Es ward Licht!!!',mtInformation,[mbOk],0);
          SchalterAn:=True;
          FeldAusgabe;
         end;
       if Inhalt=Schluessel then
        begin
         dec(Keys);
         if Doppelt then Faktor:=2 else Faktor:=1;
         inc(Punkte,LevelFaktor*Faktor*10);
         StatusPunkte.Caption:='Punkte '+IntToStr(Punkte);
         StatusKeys.Caption:='Schlssel '+IntToStr(Keys);
         if Keys=0 then // Tor blinkt
          begin
           TimerAus;
           for K:=1 to 3 do
            begin
             Ausgabe.Canvas.Draw(40*TorPos.X,40*TorPos.Y,Bild[Tor2]);
             Delay(200);
             Ausgabe.Canvas.Draw(40*TorPos.X,40*TorPos.Y,Bild[Tor]);
             if K<3 then Delay(200);
            end;
           TimerEin;
          end;
        end
       else if Inhalt=Diamant then
        begin
         Vorhanden:=False;
         for K:=1 to DListe.N do
          if (DListe.Wo[K].X=Position.X) and
             (DListe.Wo[K].Y=Position.Y) then
              begin DListe.Wo[K].X:=0;Vorhanden:=True end;
         if not Vorhanden then
          begin
           Ausgabe.Canvas.Draw(40*Position.X,40*Position.Y,Bild[Diamant]);
           Delay(50);
          end;
         Feld[AltPos.X,AltPos.Y]:=Leer;
         Ausgabe.Canvas.Draw(40*AltPos.X,40*AltPos.Y,Bild[Leer]);
         Feld[Position.X,Position.Y]:=Figur;
         Ausgabe.Canvas.Draw(40*Position.X,40*Position.Y,Bild[Figur]);
         if Doppelt then Faktor:=2 else Faktor:=1;
         inc(Punkte,LevelFaktor*Faktor*50);
         StatusPunkte.Caption:='Punkte '+IntToStr(Punkte);
        end
       else if Inhalt=Inschrift then
        begin
         TimerBonus.Enabled:=False;
         try
          InschriftBild.Inschrift.Picture.LoadFromFile('Inschrift'+IntToStr(LevelNr)+'.jpg');
          InschriftBild.ShowModal;
         except MessageDlg('Inschrift'+IntToStr(LevelNr)+'.jpg not found!',mtError,[mbOk],0);
         end;
         inc(Punkte,500);
         StatusPunkte.Caption:='Punkte '+IntToStr(Punkte);
         Ausgabe.Canvas.Draw(40*Position.X,40*Position.Y,Bild[Inschrift]);
         // Inschrift UND Diamant auf derselben Position
         for K:=1 to DListe.N do
          if (DListe.Wo[K].X=Position.X) and
             (DListe.Wo[K].Y=Position.Y) then DListe.Wo[K].X:=0;
         TimerBonus.Enabled:=True;
        end
       else if Inhalt=Tor then
        begin
         TimerAus;
         if Doppelt then Faktor:=2 else Faktor:=1;
         if Punkte-AltPunkte=LevelFaktor*Faktor*10 then
          Zeile:='Du hast den nchsten Level erreicht, Feigling!'
         else Zeile:='Du hast den nchsten Level erreicht!';
         inc(Punkte,Bonus);
         StatusPunkte.Caption:='Punkte '+IntToStr(Punkte);
         StatusHinweise.Caption:=Lob[random(LobN)+1];
         if LevelNr<LevelMax then
          MessageDlg(Zeile,mtInformation,[mbOk],0);
         if LevelNr=LevelMax then
          begin Fertig:=True;Abspann;KeyPreView:=True;exit end;
         inc(LevelNr);
         NextLevel;
         KeyPreView:=True;
         exit;
        end;
       if Beamer then BeamerTest;
       if not unsterblich then
        begin
         if Snake then SchlangenTest;
         if Speere then SpeerTest;
        end
      end;
     if Inhalt=Stein then
      begin
       Menge:=[Leer,Wasser];
       if (Key=VK_Down) and (Position.Y<Lang) and (Feld[Position.X,Position.Y+1] in Menge)then
        begin
         Feld[AltPos.X,AltPos.Y]:=Leer;
         Ausgabe.Canvas.Draw(40*AltPos.X,40*AltPos.Y,Bild[Leer]);
         Feld[Position.X,Position.Y]:=Figur;
         Ausgabe.Canvas.Draw(40*Position.X,40*Position.Y,Bild[Figur]);
         if Feld[Position.X,Position.Y+1]=Leer then // Stein wird bewegt
          begin
           Feld[Position.X,Position.Y+1]:=Stein;
           if SchalterAn then
            Ausgabe.Canvas.Draw(40*Position.X,40*(Position.Y+1),Bild[Stein]);
          end                                      // Stein fllt ins Wasser
         else
          begin
           Feld[Position.X,Position.Y+1]:=Leer;
           Ausgabe.Canvas.Draw(40*Position.X,40*(Position.Y+1),Bild[Leer]);
          end
        end
       else if (Key=VK_Up) and (Position.Y>0) and (Feld[Position.X,Position.Y-1] in Menge)then
             begin
              Feld[AltPos.X,AltPos.Y]:=Leer;
              Ausgabe.Canvas.Draw(40*AltPos.X,40*AltPos.Y,Bild[Leer]);
              Feld[Position.X,Position.Y]:=Figur;
              Ausgabe.Canvas.Draw(40*Position.X,40*Position.Y,Bild[Figur]);
              if Feld[Position.X,Position.Y-1]=Leer then
               begin
                Feld[Position.X,Position.Y-1]:=Stein;
                if SchalterAn then
                 Ausgabe.Canvas.Draw(40*Position.X,40*(Position.Y-1),Bild[Stein]);
                if LevelNr=16 then
                 if (Position.X=1) and (Position.Y-1=4) then
                  begin
                   For L:=0 to 4 do
                    begin
                     Feld[2+3*L,4]:=Leer;
                     Ausgabe.Canvas.Draw(40*(2+3*L),40*4,Bild[Leer]);
                    end;
                   Feld[9,1]:=Leer;
                   Ausgabe.Canvas.Draw(40*9,40*1,Bild[Leer]);
                   For L:=0 to 3 do
                    begin
                     Feld[4+3*L,4]:=Mauer;
                     Ausgabe.Canvas.Draw(40*(4+3*L),40*4,Bild[Mauer]);
                    end;
                  end
               end
              else
               begin
                Feld[Position.X,Position.Y-1]:=Leer;
                Ausgabe.Canvas.Draw(40*Position.X,40*(Position.Y-1),Bild[Leer]);
               end
             end
       else if (Key=VK_Left) and (Position.X>0) and (Feld[Position.X-1,Position.Y] in Menge)then
             begin
              Feld[AltPos.X,AltPos.Y]:=Leer;
              Ausgabe.Canvas.Draw(40*AltPos.X,40*AltPos.Y,Bild[Leer]);
              Feld[Position.X,Position.Y]:=Figur;
              Ausgabe.Canvas.Draw(40*Position.X,40*Position.Y,Bild[Figur]);
              if Feld[Position.X-1,Position.Y]=Leer then
               begin
                Feld[Position.X-1,Position.Y]:=Stein;
                if SchalterAn then
                 Ausgabe.Canvas.Draw(40*(Position.X-1),40*Position.Y,Bild[Stein]);
               end
              else
               begin
                Feld[Position.X-1,Position.Y]:=Leer;
                Ausgabe.Canvas.Draw(40*(Position.X-1),40*Position.Y,Bild[Leer]);
               end;
             end
       else if (Key=VK_Right) and (Position.X<Breit-1) and (Feld[Position.X+1,Position.Y] in Menge)then
             begin
              Feld[AltPos.X,AltPos.Y]:=Leer;
              Ausgabe.Canvas.Draw(40*AltPos.X,40*AltPos.Y,Bild[Leer]);
              Feld[Position.X,Position.Y]:=Figur;
              Ausgabe.Canvas.Draw(40*Position.X,40*Position.Y,Bild[Figur]);
              if Feld[Position.X+1,Position.Y]=Leer then
               begin
                Feld[Position.X+1,Position.Y]:=Stein;
                if SchalterAn then
                 Ausgabe.Canvas.Draw(40*(Position.X+1),40*Position.Y,Bild[Stein]);
               end
              else
               begin
                Feld[Position.X+1,Position.Y]:=Leer;
                Ausgabe.Canvas.Draw(40*(Position.X+1),40*Position.Y,Bild[Leer]);
               end;
             end
       else Position:=AltPos; // Stein kann nicht bewegt werden
      end
    end
   else Position:=AltPos;
   KeyPreView:=True;
  end;

procedure TPaganitzu.SoundAnClick(Sender: TObject);
  begin
   SoundAn.Checked:=not SoundAn.Checked;
   TimerEin;
  end;

 procedure TPaganitzu.SelbstTodClick(Sender: TObject);
  begin
   SelbstZerstoerung;
  end;

  procedure TPaganitzu.UhrTimer(Sender: TObject);
   begin
   DCanvas.Ellipse(Mitte.X-Radius,Mitte.Y-Radius,Mitte.X+Radius,Mitte.Y+Radius); // lschen
   inc(Mitte.X,Delta.X);inc(Mitte.Y,Delta.Y); // neue Position
   if Mitte.X>MaxX-Radius-1 then
    begin
     Mitte.X:=MaxX-Radius-1;
     Delta.X:=-Delta.X;
    end;
   if Mitte.X<Radius+1 then
    begin
     Mitte.X:=Radius+1;
     Delta.X:=-Delta.X;
    end;
   if Mitte.Y>MaxY-Radius-1 then
    begin
     Mitte.Y:=MaxY-Radius-1;
     Delta.Y:=-Delta.Y;
    end;
   if Mitte.Y<Radius+1 then
    begin
     Mitte.Y:=Radius+1;
     Delta.Y:=-Delta.Y;
    end;
   DCanvas.Ellipse(Mitte.X-Radius,Mitte.Y-Radius,Mitte.X+Radius,Mitte.Y+Radius); // neu zeichnen
  end;

 procedure TPaganitzu.ShapeGeheimMouseDown(Sender: TObject; Button: TMouseButton;
                                           Shift: TShiftState; X, Y: Integer);
  var Rect:TRect;
  begin
   if (Shift=[ssLeft]) and (MaxX=0) then
    begin
     TimerAus;
     Rect.Left:=Left;Rect.Top:=Top+40;
     Rect.Right:=Left+Width;
     Rect.Bottom:=Top+Height;
     ClipCursor(@Rect); // Mausbereich einschrnken
     Datei.Enabled:=False;
     Spiel.Enabled:=False;
     Level.Enabled:=False;
     Editor.Enabled:=False;
     Options.Enabled:=False;
     Hilfe.Enabled:=False;
     // DeskTop zerluft
     MaxX:=Screen.Width;
     MaxY:=Screen.Height;
     DHandle:=GetDC(0);
     if DHandle<>0 then
      begin
       DCanvas:=TCanvas.Create;
       DCanvas.Handle:=DHandle;
       DCanvas.Brush.Color:=Farben[random(FMax)+1];
       DCanvas.Brush.Style:=bsSolid;
       DCanvas.Pen.Mode:=pmXor; // transparent
       Mitte.X:=random(MaxX-50)+25;
       Mitte.Y:=random(MaxY-50)+25;
       Delta.X:=random(Radius)-4;
       Delta.Y:=random(Radius)-4;
       DCanvas.Ellipse(Mitte.X-Radius,Mitte.Y-Radius,Mitte.X+Radius,Mitte.Y+Radius); // zeichnen
       Uhr.Enabled:=True;
      end
     else RaiseLastOSError;
    end
   else if (Shift=[ssRight]) and (MaxX>0) then
    begin
     Uhr.Enabled:=False;
     DCanvas.Ellipse(Mitte.X-Radius,Mitte.Y-Radius,Mitte.X+Radius,Mitte.Y+Radius);
     if ReleaseDc(0,DHandle)<>1 then RaiseLastOSError;
     ClipCursor(Nil); // Maus freigeben
     MaxX:=0;
     Datei.Enabled:=True;
     Spiel.Enabled:=True;
     Level.Enabled:=True;
     Editor.Enabled:=True;
     Options.Enabled:=True;
     Hilfe.Enabled:=True;
     TimerEin;
    end;
  end;

 procedure TPaganitzu.TimerSpinneTimer(Sender: TObject);
  var K,xs,ys,xNeu,yNeu,Richtung,Versuche,Spinne,SpinnenRichtung:Integer;
      Fertig:Boolean;
      Menge:Set of Byte;
  begin
   Menge:=[Mauer,MauerStein,Fels,Granit,Leer,Wasser,Schluessel];
   for K:=1 to SpiderListe.N do
    if SpiderListe.Wo[K].X>-1 then
     begin
      xs:=SpiderListe.Wo[K].X;
      ys:=SpiderListe.Wo[K].Y;
      // neue Position ermitteln, bewegen und Test ob AL in der Nhe
      Richtung:=SpiderListe.Wo[K].Ri;Versuche:=0;
      repeat
       Fertig:=False;inc(Versuche);
       if Richtung>4 then Richtung:=1;
       if Richtung<1 then Richtung:=4;
       xNeu:=xs+RiX[Richtung];yNeu:=ys+RiY[Richtung];
       if Feld[xNeu,yNeu]<>Leer then
        begin
         if linkeHand then inc(Richtung);
         if rechteHand then dec(Richtung);
        end
       else Fertig:=True;
      until Fertig or (Versuche=5);
      if Versuche=5 then // Spinne kann sich nicht mehr bewegen
       begin
        SpiderListe.Wo[K].X:=-1; // Spinne ist tot
        Feld[xs,ys]:=Diamant; // Umwandlung in einen Diamanten
        Ausgabe.Canvas.Draw(40*xs,40*ys,Bild[Diamant]);
        if not(Feld[xs-1,ys] in Menge) then
         begin
          Feld[xs-1,ys]:=Diamant;
          Ausgabe.Canvas.Draw(40*(xs-1),40*ys,Bild[Diamant]);
         end;
        if not(Feld[xs+1,ys] in Menge) then
         begin
          Feld[xs+1,ys]:=Diamant;
          Ausgabe.Canvas.Draw(40*(xs+1),40*ys,Bild[Diamant]);
         end;
        if not(Feld[xs,ys-1] in Menge) then
         begin
          Feld[xs,ys-1]:=Diamant;
          Ausgabe.Canvas.Draw(40*xs,40*(ys-1),Bild[Diamant]);
         end;
        if not(Feld[xs,ys+1] in Menge) then
         begin
          Feld[xs,ys+1]:=Diamant;
          Ausgabe.Canvas.Draw(40*xs,40*(ys+1),Bild[Diamant]);
         end;
       end
      else
       begin
        Ausgabe.Canvas.Draw(40*xs,40*ys,Bild[Leer]); // Spinne lschen
        Feld[xs,ys]:=Leer;
        if xs>xNeu then SpinnenRichtung:=4;
        if xs<xNeu then SpinnenRichtung:=2;
        if ys<yNeu then SpinnenRichtung:=3;
        if ys>yNeu then SpinnenRichtung:=1;
        case SpinnenRichtung of
         1: Spinne:=Spinne1;
         2: Spinne:=Spinne2;
         3: Spinne:=Spinne3;
         4: Spinne:=Spinne4;
        end;
        if SchalterAn then
         Ausgabe.Canvas.Draw(40*xNeu,40*yNeu,Bild[Spinne]); // Spinne neuzeichnen
        Feld[xNeu,yNeu]:=Spinne;
        SpiderListe.Wo[K].X:=xNeu;
        SpiderListe.Wo[K].Y:=yNeu;
        if not unsterblich then
         if not SpinnenTod then
          if (Feld[xNeu-1,yNeu] in[ALL,ALR]) or (Feld[xNeu+1,yNeu] in[ALL,ALR]) or
             (Feld[xNeu,yNeu-1] in[ALL,ALR]) or (Feld[xNeu,yNeu+1] in[ALL,ALR]) then
            begin SpinnenTod:=True;LevelWiederholung;exit end; // Spinne berhrt AL
        if linkeHand then dec(Richtung);
        if rechteHand then inc(Richtung);
        if Richtung<1 then Richtung:=4;
        if Richtung>4 then Richtung:=1;
        SpiderListe.Wo[K].Ri:=Richtung;
       end
     end
  end;

 procedure TPaganitzu.Leben99Click(Sender: TObject);
  var Zahl:String;
  begin
   PasswordDlg.Caption:='langes Leben';
   PasswordDlg.LabelPasswort.Caption:='Gib deine Codezahl ein!';
   PasswordDlg.Passwort.PasswordChar:='?';
   PasswordDlg.Passwort.Text:='';
   PasswordDlg.Passwort.MaxLength:=12;
   PasswordDlg.ShowModal;
   Zahl:=PasswordDlg.Passwort.Text;
   if (Zahl=Geheim) or (Zahl='325') then // 325
    begin
     Leben:=99;
     mehrLeben:=not mehrLeben;
     if not mehrLeben then Leben:=5;
     StatusLeben.Caption:='Leben '+IntToStr(Leben);
     Leben99.Checked:=mehrLeben;
    end
   else MessageDlg('Dir fehlt der Masterkey!',mtError,[mbOk],0);
   TimerEin;
  end;

 procedure TPaganitzu.EwigClick(Sender: TObject);
  var Zahl:String;
  begin
   PasswordDlg.Caption:='ewiges Leben';
   PasswordDlg.LabelPasswort.Caption:='Gib deine Codezahl ein!';
   PasswordDlg.Passwort.PasswordChar:='?';
   PasswordDlg.Passwort.Text:='';
   PasswordDlg.Passwort.MaxLength:=12;
   PasswordDlg.ShowModal;
   Zahl:=PasswordDlg.Passwort.Text;
   if (Zahl=Geheim) or (Zahl='256') then // 256 = 2^8
    begin
     unsterblich:=not unsterblich;
     Ewig.Checked:=unsterblich;
    end
   else MessageDlg('Dir fehlt der Masterkey!',mtError,[mbOk],0);
   TimerEin;
  end;

 procedure TPaganitzu.ReichClick(Sender: TObject);
  var Zahl:String;
  begin
   PasswordDlg.Caption:='Reichtum';
   PasswordDlg.LabelPasswort.Caption:='Gib deine Codezahl ein!';
   PasswordDlg.Passwort.PasswordChar:='?';
   PasswordDlg.Passwort.Text:='';
   PasswordDlg.Passwort.MaxLength:=12;
   PasswordDlg.ShowModal;
   Zahl:=PasswordDlg.Passwort.Text;
   if (Zahl=Geheim) or (Zahl='864') then // 864
    begin
     Doppelt:=not Doppelt;
     Reich.Checked:=Doppelt;
    end
   else MessageDlg('Dir fehlt der Masterkey!',mtError,[mbOk],0);
   TimerEin;
  end;

 procedure TPaganitzu.AnfaengerClick(Sender: TObject);
  begin
   if Gestartet then
    begin
     MessageDlg('Das Spiel luft bereits!',mtError,[mbOk],0);
     TimerEin;
     exit;
    end;
   Anfaenger.Checked:=True;
   TimerSpinne.Interval:=300;
   TimerSpeer.Interval:=300;
   LevelFaktor:=1;
   StatusLevel.Caption:='Stufe 1';
  end;

 procedure TPaganitzu.FortgeschrittenerClick(Sender: TObject);
  begin
   if Gestartet then
    begin
     MessageDlg('Das Spiel luft bereits!',mtError,[mbOk],0);
     TimerEin;
     exit;
    end;
   Fortgeschrittener.Checked:=True;
   TimerSpinne.Interval:=200;
   TimerSpeer.Interval:=200;
   LevelFaktor:=2;
   StatusLevel.Caption:='Stufe 2';
  end;

 procedure TPaganitzu.ExperteClick(Sender: TObject);
  begin
   if Gestartet then
    begin
     MessageDlg('Das Spiel luft bereits!',mtError,[mbOk],0);
     TimerEin;
     exit;
    end;
   Experte.Checked:=True;
   TimerSpinne.Interval:=100;
   TimerSpeer.Interval:=100;
   LevelFaktor:=3;
   StatusLevel.Caption:='Stufe 3';
  end;

 procedure TPaganitzu.SpielstandspeichernClick(Sender: TObject);
  begin
   FileWahl.ShowModal;
   TimerEin;
  end;

 procedure TPaganitzu.TimerSnakeTimer(Sender: TObject);
  const Warte=200;
  var K,L:Integer;
  begin
   for L:=1 to 2 do
    begin
     for K:=1 to SListe.N do
      if Position.X<SListe.Wo[K].X then
       begin
        if L=1 then Ausgabe.Canvas.Draw(40*SListe.Wo[K].X,40*SListe.Wo[K].Y,Bild[Schlange])
        else Ausgabe.Canvas.Draw(40*SListe.Wo[K].X,40*SListe.Wo[K].Y,BildSchlangeL2.Picture.Bitmap);
       end
      else
       begin
        if L=1 then Ausgabe.Canvas.Draw(40*SListe.Wo[K].X,40*SListe.Wo[K].Y,BildSchlangeR.Picture.Bitmap)
        else Ausgabe.Canvas.Draw(40*SListe.Wo[K].X,40*SListe.Wo[K].Y,BildSchlangeR2.Picture.Bitmap);
       end;
     Delay(Warte);
    end
  end;

 procedure TPaganitzu.TimerDiamentenTimer(Sender: TObject);
  const Warte=200;
  var K,Index:Integer;
  begin
   Index:=0;
   for K:=1 to DListe.N do
    if DListe.Wo[K].X=0 then inc(Index);
   if Index=DListe.N then begin TimerDiamenten.Enabled:=False;Leuchten:=False;exit end;
   repeat
    Index:=random(DListe.N)+1
   until DListe.Wo[Index].X>0;
   Ausgabe.Canvas.Draw(40*DListe.Wo[Index].X,40*DListe.Wo[Index].Y,BildDiamant2.Picture.Bitmap);
   Delay(Warte);
   if DListe.Wo[Index].X>0 then // ist der Diamant noch vorhanden?
    begin
     Ausgabe.Canvas.Draw(40*DListe.Wo[Index].X,40*DListe.Wo[Index].Y,BildDiamant3.Picture.Bitmap);
     Delay(Warte);
     if DListe.Wo[Index].X>0 then
      begin
       Ausgabe.Canvas.Draw(40*DListe.Wo[Index].X,40*DListe.Wo[Index].Y,BildDiamant4.Picture.Bitmap);
       Delay(Warte);
       if DListe.Wo[Index].X>0 then
        Ausgabe.Canvas.Draw(40*DListe.Wo[Index].X,40*DListe.Wo[Index].Y,Bild[Diamant]);
      end
    end
  end;

 procedure TPaganitzu.TimerAus;
  begin
   TimerBonus.Enabled:=False;
   TimerTod.Enabled:=False;
   TimerSpinne.Enabled:=False;
   TimerSpeer.Enabled:=False;
   TimerSnake.Enabled:=False;
   TimerDiamenten.Enabled:=False;
  end;

 procedure TPaganitzu.TimerEin;
  begin
   TimerBonus.Enabled:=True;
   if Spider then TimerSpinne.Enabled:=True;
   if Snake then TimerSnake.Enabled:=True;
   if Leuchten then TimerDiamenten.Enabled:=True;
   if Speere then TimerSpeer.Enabled:=True;
   Ausgabe.Cursor:=crNone;
  end;

 procedure TPaganitzu.DateiClick(Sender: TObject);
  begin
   TimerAus;
  end;

 procedure TPaganitzu.SpielClick(Sender: TObject);
  begin
   TimerAus;
  end;

 procedure TPaganitzu.LevelClick(Sender: TObject);
  begin
   TimerAus;
  end;

 procedure TPaganitzu.OptionsClick(Sender: TObject);
  begin
   TimerAus;
  end;

 procedure TPaganitzu.HilfeClick(Sender: TObject);
  begin
   TimerAus;
  end;

 end.

