unit Spielstand;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons;

type
  TFileWahl = class(TForm)
    DateiWahl: TRadioGroup;
    ButtonSave: TSpeedButton;
    ButtonAbbruch: TSpeedButton;
    procedure ButtonSaveClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure ButtonAbbruchClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  FileWahl: TFileWahl;

implementation

uses Paga;

{$R *.dfm}

 procedure TFileWahl.ButtonSaveClick(Sender: TObject);
  const Zeichen=' SWD#)*EFMKT=^+G|;,:.?(??????I???1234zabcdefghijkl';
  var x,y,K,DateiNr:Integer;
      Datei,AltDatei,Zeile:String;
      Vorhanden:Boolean;
  begin
   if DateiWahl.ItemIndex=-1 then
    begin
     MessageDlg('Du hast keine Datei gewhlt!',mtError,[mbRetry],0);
     exit;
    end;
   AltDatei:=DateiWahl.Items[DateiWahl.ItemIndex];
   if FileExists(AltDatei) then DeleteFile(AltDatei);
   Datei:='File '+IntToStr(DateiWahl.ItemIndex+1)+' - Level '+
           IntToStr(Paganitzu.LevelNr)+'.sav';
   Paganitzu.LevelMuster.Clear;
   Paganitzu.LevelMuster.Add(IntToStr(Paganitzu.Punkte));
   Paganitzu.LevelMuster.Add(IntToStr(Paganitzu.Leben));
   Paganitzu.LevelMuster.Add(IntToStr(Paganitzu.Bonus));
   Paganitzu.LevelMuster.Add(IntToStr(Paganitzu.LevelFaktor));
   if Paganitzu.Leben99.Checked then Paganitzu.LevelMuster.Add('True')
   else Paganitzu.LevelMuster.Add('False');
   if Paganitzu.Ewig.Checked then Paganitzu.LevelMuster.Add('True')
   else Paganitzu.LevelMuster.Add('False');
   if Paganitzu.Reich.Checked then Paganitzu.LevelMuster.Add('True')
   else Paganitzu.LevelMuster.Add('False');
   if Paganitzu.SchalterAn then Paganitzu.LevelMuster.Add('True')
   else Paganitzu.LevelMuster.Add('False');
   // Beamer setzen
   for K:=1 to Paganitzu.BListe.N do
    begin
     Paganitzu.Feld[Paganitzu.BListe.Wo[K].Von.X,Paganitzu.BListe.Wo[K].Von.Y]:=K+ZusatzDiamant;
     Paganitzu.Feld[Paganitzu.BListe.Wo[K].Nach.X,Paganitzu.BListe.Wo[K].Nach.Y]:=K+ZusatzDiamant;
    end;
   // Zusatzdiamanten setzen
   for x:=0 to Breit do
    for y:=0 to Lang do
     begin
      if Paganitzu.Feld[x,y]=Diamant then
       begin
        Vorhanden:=False;
        for K:=1 to Paganitzu.DListe.N do // nach registrierten Diamanten suchen
         if (Paganitzu.DListe.Wo[K].X=x) and (Paganitzu.DListe.Wo[K].Y=y) then
          begin Vorhanden:=True;Break end;
        if not Vorhanden then Paganitzu.Feld[x,y]:=ZusatzDiamant;
       end;
     end;
   for y:=0 to Lang do
    begin
     Zeile:='';
     for x:=0 to Breit do Zeile:=Zeile+Zeichen[Paganitzu.Feld[x,y]+1];
     Paganitzu.LevelMuster.Add(Zeile);
    end;
   // Beamer wieder lschen
   for K:=1 to Paganitzu.BListe.N do
    begin
     Paganitzu.Feld[Paganitzu.BListe.Wo[K].Von.X,Paganitzu.BListe.Wo[K].Von.Y]:=Leer;
     Paganitzu.Feld[Paganitzu.BListe.Wo[K].Nach.X,Paganitzu.BListe.Wo[K].Nach.Y]:=Leer;
    end;
   // Zusatzdiamanten lschen
   for x:=0 to Breit do
    for y:=0 to Lang do
     if Paganitzu.Feld[x,y]=ZusatzDiamant then Paganitzu.Feld[x,y]:=Diamant;
   if Paganitzu.Hinweis<>'' then
    begin
     Zeile:=Paganitzu.Hinweis;
     while pos(#13,Zeile)>0 do
      begin
       Paganitzu.LevelMuster.Add(copy(Zeile,1,pos(#13,Zeile)-1));
       Delete(Zeile,1,pos(#13,Zeile));
      end;
     Paganitzu.LevelMuster.Add(Zeile);
    end;
   // codieren
   try
    DateiNr:=DateTimeToFileDate(Now);
    RandSeed:=DateiNr;
    for K:=0 to Paganitzu.LevelMuster.Count-1 do
     begin
      Zeile:=Paganitzu.LevelMuster[K];
      Paganitzu.Codieren(Zeile,1); // verschlsseln
      Paganitzu.LevelMuster[K]:=Zeile;
     end;
    Paganitzu.LevelMuster.SaveToFile(Datei);
    if FileSetDate(Datei,DateiNr)<>0 then
     MessageDlg('Fehler beim Speichern der Datei '+Datei+'!',mtError,[mbOk],0)
    else MessageDlg('gespeichert wurde '+Datei,mtInformation,[mbOk],0);
   except
     MessageDlg('Datei '+Datei+' kann nicht gespeichert werden!',mtError,[mbOk],0);
    end;
   FileWahl.Close;
  end;

 procedure TFileWahl.FormActivate(Sender: TObject);
  var Suche:TSearchRec;
      N:Integer;
  begin
   ForceCurrentDirectory:=True;
   N:=-1;DateiWahl.ItemIndex:=-1;
   if FindFirst('File*.sav',$20,Suche)=0 then // faArchive
    repeat
     inc(N);
     if N>4 then
      begin
       MessageDlg('Dateisuche wurde abbgebrochen!',mtError,[mbOk],0);
       FindClose(Suche);
       exit
      end;
     DateiWahl.Items[N]:=Suche.Name;
    until FindNext(Suche)<>0;
    FindClose(Suche);
  end;

 procedure TFileWahl.ButtonAbbruchClick(Sender: TObject);
  begin
   MessageDlg('gespeichert wurde das NICHTS'+#13+' (Michael Ende lt gren)!',mtConfirmation,[mbOk],0);
   FileWahl.Close;
  end;

end.

